﻿Imports Windows.Storage
Imports Windows.UI.Popups
Imports Windows.UI

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class DataIchiranShowPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)

        DataShow()
    End Sub

    Private Async Sub DataShow()
        GridView1.Items.Clear()
        Dim no As Integer = 0
        Dim pictureFolder As StorageFolder = KnownFolders.PicturesLibrary
        Dim pictureSubFolder As StorageFolder = Await pictureFolder.CreateFolderAsync("PhotoAlbum", CreationCollisionOption.OpenIfExists)
        Dim myPictureFiles As IReadOnlyList(Of IStorageFile) = Await pictureSubFolder.GetFilesAsync()
        If myPictureFiles.Count = 0 Then
            Dim message As New MessageDialog("画像データがありません。戻ってください。")
            Await message.ShowAsync
            Exit Sub
        End If
        For Each myFile As IStorageFile In myPictureFiles
            Dim bmp As New BitmapImage
            bmp.SetSource(Await myFile.OpenReadAsync)
            Dim myImage As New Image
            myImage.Width = 512
            myImage.Height = 384
            myImage.Source = bmp

            Dim myStackPanel As New StackPanel
            myStackPanel.Margin = New Thickness(5)

            Dim titleTextBlock As New TextBlock
            With titleTextBlock
                .Width = 512
                .TextWrapping = TextWrapping.Wrap
                .Text = Path.GetFileNameWithoutExtension(myFile.Path)
                .FontSize = 26
                .Foreground = New SolidColorBrush(Colors.Gold)
            End With

            Dim delButton As New Button
            With delButton
                .Content = "削除"
                .Tag = no.ToString
            End With

            myStackPanel.Children.Add(myImage)
            myStackPanel.Children.Add(titleTextBlock)
            myStackPanel.Children.Add(delButton)
            GridView1.Items.Add(myStackPanel)

            AddHandler delButton.Click, Async Sub(delSender As Object, delArgs As RoutedEventArgs)
                                            Dim delIndex = CInt(DirectCast(delSender, Button).Tag)
                                            Await myPictureFiles(delIndex).DeleteAsync
                                            Dim message As New MessageDialog("削除しました。")
                                            Await message.ShowAsync
                                            DataShow()
                                        End Sub

            no += 1
        Next
    End Sub
End Class
