﻿' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください
Imports Windows.Media.Capture
Imports Windows.Storage
Imports Windows.Media.MediaProperties
Imports Windows.Storage.Streams
Imports Windows.UI
Imports Windows.UI.Popups
'Imports Windows.Devices.Geolocation
Imports Windows.Devices.Enumeration
Imports Windows.UI.Core
''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    Dim myIndex As Integer

    Dim myPictureFiles As IReadOnlyList(Of IStorageFile)
    Dim myMediaCapture As MediaCapture
    Dim Index As Integer
    Dim saveBmp As BitmapImage
  
    Dim no As Integer = 0
    Dim myCamera As DeviceInformationCollection
    Dim saveImageFileName As String
    Dim flag As Boolean = False
    Dim cameraNo As Integer = -1

    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        DataShow()
        AddHandler Window.Current.VisibilityChanged, AddressOf Current_Changed
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub Current_Changed(sender As Object, e As VisibilityChangedEventArgs)
        If e.Visible = True Then
            CameraRestart()
        End If
    End Sub
    '追加処理
    Private Async Sub CameraRestart()
        myMediaCapture = CaptureElement1.Source
        myMediaCapture = New MediaCapture

        Try
            Await myMediaCapture.InitializeAsync(New MediaCaptureInitializationSettings With {.VideoDeviceId = myCamera(cameraComboBox.SelectedIndex).Id})
            CaptureElement1.Source = myMediaCapture
            Await myMediaCapture.StartPreviewAsync
        Catch
            Exit Sub
        End Try

    End Sub

    Private Async Sub DataShow()
        AppBar1.Visibility = Xaml.Visibility.Visible
        Try
            Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("PhotoAlbum", CreationCollisionOption.OpenIfExists)
            Dim myFile = Await mySubFolder.GetFilesAsync()
            If myFile.Count > 0 Then
                ichiranButton.IsEnabled = True
            Else
                PhotoArea.Children.Clear()
                ichiranButton.IsEnabled = False
            End If

            cameraComboBox.Items.Clear()

            myCamera = Await DeviceInformation.FindAllAsync(DeviceClass.VideoCapture)
            For i As Integer = 0 To myCamera.Count - 1
                Dim cameraInfo = myCamera(i)
                cameraComboBox.Items.Add(cameraInfo.Name)
            Next
            If cameraNo < 0 Then
                cameraComboBox.SelectedIndex = 0
                shutterButton.IsEnabled = True
            Else
                cameraComboBox.SelectedIndex = cameraNo
                shutterButton.IsEnabled = True
            End If

        Catch
            ErrorShow()
        End Try
    End Sub

    Private Async Sub ErrorShow()
        Dim message As New MessageDialog("カメラが装備されておりません。")
        Await message.ShowAsync
        shutterButton.IsEnabled = False
        Exit Sub
    End Sub

    Private Async Sub cameraComboBox_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles cameraComboBox.SelectionChanged
        Try
            cameraNo = cameraComboBox.SelectedIndex
            AppBar1.Visibility = Xaml.Visibility.Visible
            myMediaCapture = New MediaCapture
            Await myMediaCapture.InitializeAsync(New MediaCaptureInitializationSettings With {.VideoDeviceId = myCamera(cameraComboBox.SelectedIndex).Id})
            CaptureElement1.Source = myMediaCapture
            Await myMediaCapture.StartPreviewAsync
            shutterButton.IsEnabled = True
        Catch
            Exit Sub
        End Try
    End Sub

    Private Async Sub shutterButton_Click(sender As Object, e As RoutedEventArgs) Handles shutterButton.Click
        MediaElement1.Play()
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("PhotoAlbum", CreationCollisionOption.OpenIfExists)
        Dim myFile As StorageFile = Await mySubFolder.CreateFileAsync(DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".png")
        saveImageFileName = DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".png"
        Dim myImageEncodingProperty As New ImageEncodingProperties
        myImageEncodingProperty.Subtype = "png"
        myImageEncodingProperty.Width = 640
        myImageEncodingProperty.Height = 480
        
            Await myMediaCapture.CapturePhotoToStorageFileAsync(myImageEncodingProperty, myFile)

        myPictureFiles = Await mySubFolder.GetFilesAsync()
        Index = myPictureFiles.Count
        saveBmp = New BitmapImage
        saveBmp.SetSource(Await myPictureFiles(Index - 1).OpenReadAsync)
        Dim myImage As New Image
        With myImage
            .Width = 320
            .Height = 240
            .Source = saveBmp
        End With

        Dim myStackPanel As New StackPanel
        With myStackPanel
            .RenderTransform = New CompositeTransform
            .ManipulationMode = ManipulationModes.All
            .SetValue(Canvas.ZIndexProperty, no)
        End With

        Dim delButton As New Button
        delButton.Content = "削除"
        delButton.Tag = no.ToString


        myStackPanel.Children.Add(myImage)
        myStackPanel.Children.Add(delButton)

        PhotoArea.Children.Add(myStackPanel)

        AddHandler myStackPanel.ManipulationDelta, Sub(mySender As Object, myArgs As ManipulationDeltaRoutedEventArgs)
                                                       Dim myTrans = DirectCast(myStackPanel.RenderTransform, CompositeTransform)

                                                       myTrans.TranslateX = myTrans.TranslateX + myArgs.Delta.Translation.X
                                                       myTrans.TranslateY = myTrans.TranslateY + myArgs.Delta.Translation.Y

                                                       myTrans.ScaleX = myTrans.ScaleX * myArgs.Delta.Scale
                                                       myTrans.ScaleY = myTrans.ScaleY * myArgs.Delta.Scale

                                                       myTrans.CenterX = 320
                                                       myTrans.CenterY = 240
                                                       myTrans.Rotation = myTrans.Rotation + myArgs.Delta.Rotation
                                                       myStackPanel.SetValue(Canvas.ZIndexProperty, no)

                                                   End Sub

        AddHandler delButton.Click, Async Sub(delSender As Object, delArgs As RoutedEventArgs)
                                        Dim delIndex = CInt(DirectCast(delSender, Button).Tag)
                                        Await myPictureFiles(delIndex).DeleteAsync
                                        Dim message As New MessageDialog("削除しました。")
                                        Await message.ShowAsync
                                        DataReload()
                                    End Sub
        no = no + 1
        ichiranButton.IsEnabled = True
    End Sub

    Private Async Sub DataReload()
        PhotoArea.Children.Clear()
        no = 0
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("PhotoAlbum", CreationCollisionOption.OpenIfExists)

        myPictureFiles = Await mySubFolder.GetFilesAsync()

        For Each myFile As IStorageFile In myPictureFiles
            saveBmp = New BitmapImage
            saveBmp.SetSource(Await myFile.OpenReadAsync)
            Dim myImage As New Image
            With myImage
                .Width = 320
                .Height = 240
                .Source = saveBmp
            End With

            Dim myStackPanel As New StackPanel
            With myStackPanel
                .RenderTransform = New CompositeTransform
                .ManipulationMode = ManipulationModes.All
            End With

            Dim delButton As New Button
            delButton.Content = "削除"
            delButton.Tag = no.ToString


            myStackPanel.Children.Add(myImage)
            myStackPanel.Children.Add(delButton)

            PhotoArea.Children.Add(myStackPanel)


            AddHandler myStackPanel.ManipulationDelta, Sub(mySender As Object, myArgs As ManipulationDeltaRoutedEventArgs)
                                                           Dim myTrans = DirectCast(myStackPanel.RenderTransform, CompositeTransform)

                                                           myTrans.TranslateX = myTrans.TranslateX + myArgs.Delta.Translation.X
                                                           myTrans.TranslateY = myTrans.TranslateY + myArgs.Delta.Translation.Y

                                                           myTrans.ScaleX = myTrans.ScaleX * myArgs.Delta.Scale
                                                           myTrans.ScaleY = myTrans.ScaleY * myArgs.Delta.Scale

                                                           myTrans.CenterX = 320
                                                           myTrans.CenterY = 240
                                                           myTrans.Rotation = myTrans.Rotation + myArgs.Delta.Rotation
                                                           myStackPanel.SetValue(Canvas.ZIndexProperty, no)

                                                       End Sub
            AddHandler delButton.Click, Async Sub(delSender As Object, delArgs As RoutedEventArgs)
                                            Dim delIndex = CInt(DirectCast(delSender, Button).Tag)
                                            If delIndex < 0 Then
                                                ichiranButton.IsEnabled = False
                                            Else
                                                ichiranButton.IsEnabled = True
                                            End If
                                            Await myPictureFiles(delIndex).DeleteAsync
                                            Dim message As New MessageDialog("削除しました。")
                                            Await message.ShowAsync
                                            DataReload()
                                        End Sub


            no = no + 1
        Next
    End Sub


    Private Sub backButton_Click(sender As Object, e As RoutedEventArgs) Handles backButton.Click
        PhotoArea.Visibility = Xaml.Visibility.Visible

        cameraComboBox.Visibility = Xaml.Visibility.Visible
        AppBar1.Visibility = Xaml.Visibility.Visible
        AppBar1.IsEnabled = True
        myFrame.Visibility = Xaml.Visibility.Collapsed
        DataShow()
        DataReload()
    End Sub

    Private Sub ichiranButton_Click(sender As Object, e As RoutedEventArgs) Handles ichiranButton.Click
        PhotoArea.Visibility = Xaml.Visibility.Collapsed
        cameraComboBox.Visibility = Xaml.Visibility.Collapsed
        myFrame.Visibility = Xaml.Visibility.Visible
        AppBar1.Visibility = Xaml.Visibility.Collapsed
        myFrame.Navigate(GetType(DataIchiranShowPage), Nothing)
    End Sub

    Private Async Sub myApps_Click(sender As Object, e As RoutedEventArgs) Handles myApps.Click
        Dim myAppsUri = New Uri("ms-windows-store:Search?query=kuniyasu")
        Await Windows.System.Launcher.LaunchUriAsync(myAppsUri)
    End Sub
End Class
